package com.madeu.controller.web.webstocksumadjustment;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.core.io.Resource;
import org.springframework.core.io.UrlResource;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.ModelAndView;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.web.webloghistory.WebLogHistoryService;
import com.madeu.service.web.webstocksumadjustment.WebStockSumAdjustmentService;
import com.madeu.util.HttpUtil;
import com.madeu.view.web.WebStockSumAdjustmentView;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;


@Slf4j
@Controller
public class WebStockSumAdjustmentController extends ManagerDraftAction{

	@Autowired
	private WebStockSumAdjustmentService webStockSumAdjustmentService;
	
	/**
	 * 제품별 실시간 재고 현황 리스트 (재고조정 화면) 리스트 조회 화면으로 이동.
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webstocksumadjustment/selectListStockSumAdjustmentIntro.do")
	public String  selectListStockSumAdjustmentIntro(HttpSession session,HttpServletRequest request, HttpServletResponse response, Model model) {
		log.debug("WebStockSumAdjustmentController  selectListStockSumAdjustmentIntro START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return "/web/login/logout";
			}
			else {
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webStockSumAdjustmentService.selectListStockSumAdjustmentIntro(paramMap);
				
				model.addAttribute("selectUseYn", map.get("selectUseYn"));
				model.addAttribute("insertUseYn", map.get("insertUseYn"));
				model.addAttribute("updateUseYn", map.get("updateUseYn"));
				model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
				model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return "/web/login/logout";
		}
		log.debug("WebStockSumAdjustmentController  selectListStockSumAdjustmentIntro END");
		return "/web/stocksumadjustment/stockSumAdjustmentSelectList";
	}
	
	/**
	 * 제품별 실시간 재고 현황 리스트 (재고조정 화면) 조회
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webstocksumadjustment/selectListStockSumAdjustment.do")
	public ModelAndView selectListStockSumAdjustment(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebStockSumAdjustmentController selectListStockSumAdjustment START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webStockSumAdjustmentService.selectListStockSumAdjustment(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("WebStockSumAdjustmentController selectListStockSumAdjustment END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
	
	/**
	 * <b> 제품별 실시간 재고 현황 리스트 (재고조정 화면) 엑셀 다운로드 </b>
	 * 페이지 처리 없음 
	 * request: 
	 * response : msgCode, msgDesc
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webstocksumadjustment/downloadStockSumAdjustmentExcel.do")
	public ModelAndView downloadStockSumAdjustmentExcel(HttpSession session, HttpServletRequest request, HttpServletResponse response, @RequestParam(value = "file", required = false) MultipartFile file, Model model) {
		log.debug("WebStockSumAdjustmentController downloadStockSumAdjustmentExcel START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		Map<String, Object> selectListReport = new HashMap<String,Object>();
		Map<String, Object> map = new HashMap<String,Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				selectListReport = webStockSumAdjustmentService.selectListStockSumAdjustmentExcel(paramMap);
				map.put("selectListStockSumAdjustment", selectListReport);
				map.put("name", "stocksumadjustment");
			}
		}
		catch(Exception e){
			e.printStackTrace();
			return null;
		}
		log.debug("WebStockSumAdjustmentController downloadStockSumAdjustmentExcel END");
		return new ModelAndView(new WebStockSumAdjustmentView(),"map",map);
	}
}
